//XML2BibTeX.java
//Jonas Pohlandt 2002
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.dom.DOMSource;
import org.xml.sax.SAXException;
import org.w3c.dom.*;
import java.io.*;

class XML2BibTeX {
	
    private static MySaxErrorHandler mySaxEH;
    private static File in;
    private static File stylesheet;
    private static FileWriter out;
    //Pfad zum Stylesheet
    //private static String stylesheetpath = BibSearchRessourceLocator.
    //    getXSLPath() + "BibTeX.xsl";
    private static String stylesheetpath = "BibTeX.xsl";
    public static void main(String[] args) {
    	
    	boolean outexists = true;
    	FileReader test;
    	
    	// Syntax gltig?
    	if (args.length == 2) {
    	        	    
    	    try {
    	    	// XML Datei und Stylesheet vorhanden?
    	        test = new FileReader(args[0]);
    	        test = new FileReader(stylesheetpath);
    	        in = new File(args[0]);
    	        stylesheet = new File(stylesheetpath);
            } catch (IOException ioe) {
                System.out.println(ioe.getMessage());
                System.exit(0);
            }
            try {
            	 // Gibt es das outfile bereits?
                 test = new FileReader(args[1]);
            } catch (IOException ioe) {
            	// outfile noch nicht vorhanden, muss also angelegt 
            	// werden
            	outexists = false;
            	try {
            	    //outfile anlegen
            	    File f = new File(args[1]);                 
            	    out = new FileWriter(f);
            	} catch (IOException ioe2) {
            	    System.out.println(ioe2.getMessage());
                    System.exit(0);
                }    
            }
            // Gibt es das outfile schon sollte der Benutzer davor 
            // gewarnt werden, da es berschrieben wird.
            if (outexists) {
                try {
                    InputStreamReader isr = 
                        new InputStreamReader(System.in);
                    BufferedReader br = new BufferedReader(isr);
                    System.out.println("Achtung: Datei " + args[1] 
                    + " wird berschrieben. Alle in ihr"
                    + " enthaltenen Daten gehen verloren.\n");
                    System.out.println("Fortfahren? [j/n]: ");
                    String answer = br.readLine();
                    if (!(answer.equals("j"))) {
                        System.out.println("\nAbbruch durch "
                        + "Benutzer.\n");
                        System.exit(0);
                    }
                    out = new FileWriter(args[1]);
                } catch (IOException ioe) {
                	    System.out.println(ioe.getMessage());
                        System.exit(0);
                }
            }
            
            // xml ins bibtex format umwandeln
            transform(in, out, stylesheet);
            
            // diakritische Zeichen ins latex format umwandeln
            substitute(new File(args[1]));
            
    	} else {
    	    System.out.println("Usage: java XML2BibTeX Infile "
    	    + "Outfile\n");
    	}
    }
    

    public static void substitute(File subsfile) {
    	/* Code um Buchstaben einzeln zu ersetzen
    	   ** Unntig durch Einsatz von recode weiter unten **
    	   
    	  try {
    	    String regexp;
            String subs;
            StringWriter sw = new StringWriter();
            FileReader fr   = new FileReader(subsfile);
            // char Array von der Grsse der Datei Anlegen
            char[]     cbuf = new char[(int) subsfile.length()];
            // cbuf mit inhalt der datei fllen
            fr.read(cbuf);
            //sw mit cbuf fllen
            sw.write(cbuf);
            // inhalt von sw ergibt neuen string s
            String s = sw.toString();
            
            //Substitutionen durchfhren
            regexp = new String("");
            subs = new String("\\\\" + "\"{a}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\\"{o}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\\"{u}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\\"{A}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\\"{O}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\\"{U}");
            s = s.replaceAll(regexp, subs);
            
            regexp = new String("");
            subs = new String("\\\\ss");
            s = s.replaceAll(regexp, subs);
            
            StringReader sr = new StringReader(s);
            cbuf = new char[(int) s.length()];
            sr.read(cbuf);
            FileWriter fw = new FileWriter(subsfile);
            fw.write(cbuf);
            fw.close();
            
            
        
        // mgliche Exceptions fangen    
        } catch (IOException e) {
            
        }
        */
        
        // Durch Aufruf von recode werden diakritische 
        // Zeichen ins latex Format umgewandelt
        
        try {
        java.lang.Runtime.getRuntime().exec("recode ltex " + subsfile.toString()); 
        } catch (IOException ioe) {
            System.out.println(ioe.getMessage());
            System.exit(0);
        }
    }

    public static void transform(File in, FileWriter out, 
        File stylesheet) {
        
        // Aus dem XML File wird zuerst ein Dom Document gemacht,
        // dieses dann per XSLT transformiert.
        Document document;
        DocumentBuilderFactory factory = DocumentBuilderFactory.
            newInstance();
                
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            builder.setErrorHandler(mySaxEH);
            document = builder.parse(in);
	
	    // Neuen Transformer per TransformerFactory erzeugen.
            TransformerFactory tFactory    = TransformerFactory.
                newInstance();
            StreamSource       stylesource = new 
                StreamSource(stylesheet);
            
            // Der neue Transformer benutzt die Transfomierungsregeln
            // aus dem Stylesheet
            Transformer        transformer =
                tFactory.newTransformer(stylesource);
        
            DOMSource    source = new DOMSource(document);
            StreamResult result = new StreamResult(out);

            transformer.transform(source, result);
            
            out.close();
        
        // Mgliche Exceptions fangen
        } catch (SAXException sxe) {
            Exception x = sxe;
            if (sxe.getException() != null) {
                x = sxe.getException();
            }
            x.printStackTrace();
        } catch (ParserConfigurationException pce) {
            pce.printStackTrace();
        } catch (TransformerConfigurationException tce) {
            System.out.println("\n** Transformer Factory error");
            System.out.println("   " + tce.getMessage());
            Throwable x = tce;
            if (tce.getException() != null) {
                x = tce.getException();
            }
            x.printStackTrace();
        } catch (TransformerException te) {
            System.out.println("\n** Transformation error");
            System.out.println("   " + te.getMessage());
            Throwable x = te;
            if (te.getException() != null) {
                x = te.getException();
            }
            x.printStackTrace();
        } catch (IOException ioe) {
            System.out.println(ioe.getMessage());
            System.exit(0);
        }
    }
}